module ListComp where

import Data.Char

-- Examples for list comprehension:

digits :: String-> [Int]
digits str = [ord x -ord '0'| x<- str, isDigit x]        

idx:: [String]
idx = [ a: show i| a<- ['a'.. 'z'], i<- [0.. 9]]

-- Quicksort:

qsort :: Ord alpha=> [alpha]-> [alpha]
qsort [] = []
qsort xs@(x:_) = qsort [y | y<- xs, y< x]++ 
                       [x0| x0<- xs, x0 == x]++
                 qsort [z| z<- xs,  z< x]
