module Tree where

data Tree alpha = Mt | Node alpha (Tree alpha) (Tree alpha)

foldT :: (alpha-> beta-> beta-> beta)-> beta-> Tree alpha-> beta
foldT f e Mt = e
foldT f e (Node a l r) =  f a (foldT f e l) (foldT f e r)

-- Hhe mit foldT
height :: Tree alpha-> Int
height = foldT (\_ l r-> 1+ max l r) 0

-- Inorder-Traversion mit foldT
inorder :: Tree alpha-> [alpha]
inorder = foldT (\a l r-> l++ [a]++ r) []

